#include <stdio.h>

struct date {
  int day, month, year;
};

void incday0(struct date d) {
  d.day++;
}

void incday1(struct date *d) {
  d->day++;
}

void printday(const struct date *d) {
	printf("%d/%d/%d\n", d->day, d->month, d->year);
}

int datecmp(struct date d1, struct date d2) {
  if (d1.year < d2.year) 
    return(-1);
  else if (d1.year > d2.year) 
    return(1);
  else if (d1.month < d2.month) 
    return(-1);
  else if (d1.month > d2.month) 
    return(1);
  else if (d1.day < d2.day) 
    return(-1);
  else if (d1.day > d2.day) 
    return(1);
  else 
    return(0);
}

int main(int argc, char *argv[]) {
  struct date d1, d2, *dptr; 
  struct date d[2];
  int res;
  
  printf("Enter day/month/year: ");

  scanf("%d/%d/%d", &d1.day, &d1.month, &d1.year);
  
  printf("d1 is: ");
  printday(&d1);

  d2 = d1;
  printf("d2 is: ");
  printday(&d2);
  
  incday0(d1);
  printf("d1 is: ");
  printday(&d1);

  incday1(&d2);
  printf("d2 is: ");
  printday(&d2);
  
  dptr = &d2;
  incday1(dptr);
  printf("d2 (via dptr) is: ");
  printday(dptr);
  
  res =  datecmp(d1,d2);
  if (res > 0) 
	  printf("d1 after d2\n");
  else if (res < 0)
	  printf("d1 before d2\n");
  else
	  printf("d1 equal to d2\n");
  
  res =  datecmp(d1,*dptr);
  if (res > 0) 
	  printf("d1 after d2 (via dptr)\n");
  else if (res < 0)
	  printf("d1 before d2 (via dptr)\n");
  else
	  printf("d1 equal to d2 (via dptr)\n");
  
  d[0] = d1; 
  d[1] = d2;
  
  dptr = d;
  incday1(dptr);
  printf("d[0] (via dptr) is: ");
  printday(&d[0]);
  
  dptr++;
  incday1(dptr);
  printf("d[1] (via dptr) is: ");
  printday(&d[1]);
    
  return(0);
}
